#! /usr/bin/perl

#
# Login script for the SE-3 2004 dungeon.
# B. Ulmann fecit, 06-MAY-2004
#

# Be sure to warn on undeclared variables, etc.
use strict;
use warnings;
use DBI;

# $debug = 1 results in some debug output - this is a global variable! :-)
my $debug = 0;

# Connect to database
sub conn
{
    my ($driver, $database, $hostname, $port, $user, $password) = @_;

    if ($debug)
    {
	print "DEBUG: conn ()<br>\n";
    }

    my $dsn = "DBI:$driver:database=$database;host=$hostname;port=$port";
    my $dbh = DBI -> connect ($dsn, $user, $password); # Connect to database

    die "<b>conn (): Could not connect to database!" unless $dbh; # Did not work
    die "<b>conn (): Connection error: ", $dbh -> errstr if $dbh -> err;

    print "<hr>\n" if $debug;

    return $dbh;
}

sub check_login 
{
    my ($dbh, $name, $password, $dungeon_cgi) = @_;

    if ($debug)
    {
	print "DEBUG: check_login ()<br><ul><li>name=$name<li>password=$password</ul>\n";
    }

    my $statement = "select last_lnr, unr
from users
where nickname=\"$name\"
and password=\"$password\"";
    my $sth = $dbh -> prepare ($statement);
    $sth -> execute;

    if ($sth -> err)
    {
	print "<b>ERROR!", $sth -> errstr, "</b></body></html>";

	$sth -> finish;
	$dbh -> disconnect;

	exit;
    }

    my ($last_lnr, $unr);
    $sth -> bind_columns (\$last_lnr, \$unr);

    if (!$sth -> fetch)
    {
	print "<center><h1><font color=\"red\">Illegal login!</font></h1></center>", $sth -> errstr, "</b>";

	$sth -> finish;
	$dbh -> disconnect;
    }
    else
    {
	$sth -> finish;
	$dbh -> disconnect;

	if ($debug)
	{
	    print "<br><ul><li>lnr = $last_lnr</li><li>unr = $unr</li></ul><br>";
	}

	print "<center><h1>Welcome to the dungeon</h1><br>
<center><form action=\"$dungeon_cgi\" method=\"POST\">
 <input type=\"submit\" value=\"Start dungeon\">
 <input type=\"hidden\" name=\"unr\" value=\"$unr\">
 <input type=\"hidden\" name=\"login\" value=\"1\">
\n";

	print " <input type=\"hidden\" name=\"lnr\" value=\"$last_lnr\">\n" if $last_lnr;

     print "
</form></center></body></html>";

	exit;
    }
}

sub create_account
{
    my ($dbh, $name, $password, $dungeon_cgi) = @_;

    if ($debug)
    {
	print "DEBUG: create_account ()<br><ul><li>name=$name<li>password=$password</ul>\n";
    }

    my $statement = "insert into users (nickname, password) values (\"$name\", \"$password\")";
    my $sth = $dbh -> prepare ($statement);
    $sth -> execute;

    if ($sth -> err)
    {
	print "<b>Could not create new account. Error: ", $sth -> errstr;
	$sth -> finish;
	$dbh -> disconnect;
	exit;
    }
    else
    {
	$sth -> finish;

	# Determine new unr
	$statement = "select unr
from users
where nickname=\"$name\"
and password=\"$password\"";

	$sth = $dbh -> prepare ($statement);
	$sth -> execute;

	if ($sth -> err)
	{
	    print "<b>ERROR!", $sth -> errstr, "</b></body></html>";

	    $sth -> finish;
	    $dbh -> disconnect;

	    exit;
	}

	my $unr;
	$sth -> bind_columns (\$unr);

	if (!$sth -> fetch)
	{
	    print "<center><h1><font color=\"red\">Illegal login!</font></h1></center>", $sth -> errstr, "</b>";

	    $sth -> finish;
	    $dbh -> disconnect;

	    exit;
	}
	$sth -> finish;
	$dbh -> disconnect;

	print "<center><h1>Welcome to the dungeon</h1><br>
<center><form action=\"$dungeon_cgi\" method=\"POST\">
 <input type=\"submit\" value=\"Start dungeon\">
 <input type=\"hidden\" name=\"unr\" value=\"$unr\">
 <input type=\"hidden\" name=\"login\" value=\"1\">
</form></center></body></html>";

	exit;
    }

    exit;
}

sub create_form 
{
    my $cgi = $_[0];

    if ($debug)
    {
	print "DEBUG: create_form ()<br>\n";
    }

    print "
  <form action=\"$cgi\" method=\"POST\">
   <center>
    <table>
     <tr>
      <td>Name</td>
      <td><input name=\"name\" type=\"input\" cols=\"20\"></td>
     </tr>
     <tr>
      <td>Password</td>
      <td><input name=\"password\" type=\"password\" cols=\"20\"></td>
     </tr>
     <tr>
      <td>
       <input name=\"action\" type=\"submit\" value=\"Login\">
      </td>
      <td>
       <input name=\"action\" type=\"submit\" value=\"New User\">
      </td>
     </tr>
    </table>
   </center
  </form>
";
}

#########################################################################################
#
# main program
#
#########################################################################################

# Set access parameters:
my $driver = "mysql";
my $database = "dungeon";
my $hostname = "localhost";
my $port = 3306;
my $user = "dungeon";
my $password = "keeper";
my $picture_prefix = '';
my $cgi = "login.pl"; # Name of the cgi to be called
my $dungeon_cgi = 'd1.pl';

# Some more variables
my $lnr; # Initial location number

# first_run = 1 denotes that the script was called for the first time
my $first_run = 1;

# Prepare the output of HTML code:
print "Content-type: text/html

<html>
 <body bgcolor=\"3333FF\">
";

if ($debug) # We are running in debug mode!
{
    print "<center><b>Running in debug mode!</b></center><hr>\n";
}

# Read parameters from GET or POST access:
my ($buffer, @pairs, $pair, $name, $value, %FORM);

# Read in text
$ENV{'REQUEST_METHOD'} =~ tr/a-z/A-Z/;
if ($ENV{'REQUEST_METHOD'} eq "POST")
{
    read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else # Not POST -> GET :-)
{
    $buffer = $ENV{'QUERY_STRING'};
}

# Split information into name/value pairs
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%(..)/pack("C", hex($1))/eg;

    $FORM{$name} = $value;
    $first_run = 0;
}

# Dump parameters:
if ($debug)
{
    print "DEBUG: Parameters:<br><ul><li>first_run = $first_run\n";
    foreach my $key (keys %FORM)
    {
	print "<li>$key = $FORM{$key}\n";
    }
    print "</ul>\n";
}

my $dbh;

if (!$first_run)
{
    # Connect to database
    $dbh = conn ($driver, $database, $hostname, $port, $user, $password);
    if ($FORM{'action'} eq 'Login')
    {
	check_login ($dbh, $FORM{'name'}, $FORM{'password'}, $dungeon_cgi);
    }
    elsif ($FORM{'action'} eq 'New User') # Create a new account
    {
	create_account ($dbh, $FORM{'name'}, $FORM{'password'}, $dungeon_cgi);
    }
    else
    {
	print "<h1>Completely unknown operation!</h1>";
    }
}

# Create form
create_form ($cgi);

print " </body>
</html>
";

$dbh -> disconnect if !$first_run;







